#include <iostream>

using namespace std;

int main()
{
    int n, q;
    cin>>n>>q;
    int niz[n];
    int ispis[q];

    for(int i=0; i<n; i++){
        cin>>niz[i];
    }

    for(int k=0; k<q; k++){
        int l, r;
        cin>>l>>r;

        int brojac = 0;
        for(int j=l-1; j<r; j++){
            if(niz[j] == 1){
                brojac++;
            }
        }
        if(brojac == r-l+1){
            ispis[k] = 1;
        }
        else{
            ispis[k] = 0;
        }
    }

    for(int i=0; i<q; i++){
        cout<<ispis[i]<<endl;
    }
    return 0;
}